01/16/2015 07:35 AM - Jure Pecar

Status: New   

Priority: Normal   

Assignee:    

Category: Parameters   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases: 1.6.3

Bugzilla link:  Red Hat JIRA:  
Description

I have a class that takes $custom_routes parameter that is fed to a template:

<% custom_routes.each_line do |val| ->

<= val >

< end -%>

I enter some lines for parameter in foreman:

192.168.0.0/24 via 192.168.128.1

192.168.10.0/24 via 192.168.128.1

192.168.2.0/24 via 192.168.128.1

I get this in the resulting file on the client:

192.168.0.0/24 via 192.168.128.1^M

192.168.10.0/24 via 192.168.128.1^M

192.168.2.0/24 via 192.168.128.1

As a result system init script fails to set up static routes correctly.

First I tought this to be a browser issue (opera), but the same happens in firefox. So it must happen further down the stack, likely

somewhere in foreman or maybe in rubys handling of .each_line.

Puppetmaster has ruby 2.0.0 and puppet 3.6.3, client has ruby 1.8.7 and puppet 3.7.1.

Any hints on how to fix / work around this?

Related issues:

Related to Foreman - Bug #19472: Smart Class Parameter adding \r to strings a... New

History

#1 - 01/16/2015 07:42 AM - Dominic Cleal

- Category set to Parameters

.each_line splits on the new line character(s) for the OS it's running on.  You could do .each_line("\r\n") to split on CRLF instead.

I guess your browser is running on Windows?  We munge CRLF in other places in Foreman, parameters could do the same.

#2 - 01/16/2015 07:52 AM - Jure Pecar

No, my workstation is linux.

With .each_line("\r\n") the resulting static route file is the same, so it doesn't fix the problem.

#3 - 01/16/2015 07:54 AM - Dominic Cleal

Try using val.chomp to remove trailing whitespace?
#4 - 01/16/2015 08:08 AM - Jure Pecar

Ok, this workaround wokrs, thanks.

#5 - 05/08/2017 03:12 AM - Dominic Cleal

- Related to Bug #19472: Smart Class Parameter adding \r to strings and issues with ""s added
